#include "V_Trading.mqh"

static int prevtime = 0;
static bool openbarspriceonly = true;
static int period = 30;

int V_Spreader( string first_instrument, string seconds_instrument, double lots, double profit )
  {
   int total = V_OrdersTotal();
   int currentticket = -1;
   int secondticket = -1;
   
   //     
   int currenttype = OP_SELL;
   //     
   int secondtype = OP_BUY;

   double currentprofit = 0;
   
    double secondlots = 0;

   for (int i = 0; i < total; i++) {
      V_OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (V_OrderSymbol() == first_instrument) {
         currentticket = V_OrderTicket();
         currentprofit = currentprofit + V_OrderProfit();
         currenttype = V_OrderType();
      }
      if (V_OrderSymbol() == seconds_instrument) {
         secondticket = V_OrderTicket();
         secondtype = V_OrderType();
         currentprofit = currentprofit + V_OrderProfit();
         secondlots = V_OrderLots();
      }
   }


   if ((secondticket < 0) && (currentticket >= 0)) {
      Comment("Try close positon for " + first_instrument);
      if (currenttype == OP_BUY) {
         if (V_OrderClose(currentticket, lots, V_MarketInfo(first_instrument, MODE_BID), 2, Blue)) {
            openbarspriceonly = true;
         }
         return(0);
      } else {
         if (V_OrderClose(currentticket, lots, V_MarketInfo(first_instrument, MODE_ASK), 2, Red)) {
            openbarspriceonly = true;
         }
         return(0);
      }
   }

   if ((secondticket >= 0) && (currentticket >= 0)) {
      openbarspriceonly = false;
      if (currentprofit > profit) {
         if (secondtype == OP_BUY) {
            V_OrderClose(secondticket, secondlots, V_MarketInfo(seconds_instrument, MODE_BID), 2, Blue);
            return(0);
         } else {
            V_OrderClose(secondticket, secondlots, V_MarketInfo(seconds_instrument, MODE_ASK), 2, Red);
            return(0);
         }
      }
      if (currentprofit <  -6.0 * profit) {
         if (secondtype == OP_BUY) {
            V_OrderClose(secondticket, secondlots, V_MarketInfo(seconds_instrument, MODE_BID), 2, Blue);
            return(0);
         } else {
            V_OrderClose(secondticket, secondlots, V_MarketInfo(seconds_instrument, MODE_ASK), 2, Red);
            return(0);
         }
      }
      //      
      Comment("Positions for " + first_instrument + " and " + seconds_instrument + " is open.\nTotal profit: $" + currentprofit);
      return(0);
   }

   openbarspriceonly = true;

   if ((secondticket >= 0) && (currentticket < 0)) {
      Comment("Try open positon for " + first_instrument);
      //      
      //      
      if (secondtype == OP_SELL) {
         currentticket = V_OrderSend(first_instrument, OP_BUY, lots, V_MarketInfo(first_instrument, MODE_ASK), 2, 0, 0, WindowExpertName(), 0, 0, Blue); 
      } else {
         currentticket = V_OrderSend(first_instrument, OP_SELL, lots, V_MarketInfo(first_instrument, MODE_BID), 2, 0, 0, WindowExpertName(), 0, 0, Red); 
      }
      return(0);
   }
   
   if (MarketInfo(first_instrument, MODE_LOTSIZE) != MarketInfo(seconds_instrument, MODE_LOTSIZE)) {
      Alert("Contracts size not equals. Change instruments");
      return(0);
   }

   //        

   double x1 = V_iClose(first_instrument, Period(), 0) - V_iClose(first_instrument, Period(), period); 
   double x2 = V_iClose(first_instrument, Period(), period) - V_iClose(first_instrument, Period(), period * 2); 
   double y1 = V_iClose(seconds_instrument, Period(), 0) - V_iClose(seconds_instrument, Period(), period); 
   double y2 = V_iClose(seconds_instrument, Period(), period) - V_iClose(seconds_instrument, Period(), period * 2); 
//----

   //    
   
   if ((x1 * x2) > 0) {
      //     
      //    
      Comment(first_instrument + " trend found");
      return(0); 
   }

   if ((y1 * y2) > 0) {
      //     
      //    
      Comment(seconds_instrument + " trend found");
      return(0);
   }
   
   //     

   if ((x1 * y1) > 0) {
      
      //     
      
      double a = MathAbs(x1) + MathAbs(x2);
      double b = MathAbs(y1) + MathAbs(y2);
      
      if ((a / b) > 3.0) {
         return(0);
      }
      
      if ((a / b) < 0.3) {
         return(0);
      }

      //     
      secondlots = NormalizeDouble(a  * lots / b, 2);
      
      //     24 
      double x3 = V_iClose(first_instrument, Period(), 0) - V_iClose(first_instrument, Period(), 1440);
      double y3 = V_iClose(seconds_instrument, Period(), 0) - V_iClose(seconds_instrument, Period(), 1440);
      
      //     
      if ((x1 * b) > (y1 * a)) {
         //     24 
         if ((x3 * b) < (y3 * a)) {
            Comment("False testimony");
            return(0); //  
         }
         currenttype = OP_BUY;
      } else {
         //     24 
         if ((x3 * b) > (y3 * a)) {
            Comment("False testimony");
            return(0);  //  
         }
      }
   } else {
      //     
      Comment("Negative correlation found");
      return(0);
   }

   //     
   
   if (currenttype == OP_SELL) {
      secondticket = V_OrderSend(seconds_instrument, OP_BUY, secondlots, V_MarketInfo(seconds_instrument, MODE_ASK), 2, 0, 0, WindowExpertName(), 0, 0, Blue); 
   } else {
      secondticket = V_OrderSend(seconds_instrument, OP_SELL, secondlots, V_MarketInfo(seconds_instrument, MODE_BID), 2, 0, 0, WindowExpertName(), 0, 0, Red); 
   }
   
   if (secondticket >= 0) {
      openbarspriceonly = false;
   }

   return(0);
  }